<template>
  <div class="content" v-if="detail">
    <div class="block menu">
      <div class="button"><router-link :to="{ 'name': 'default'}">< Back</router-link></div>
    </div>
    <div class="detail-container">
      <div class="detail">
        <div class="cover"><img :src="'https://beatsaver.com/img/' + detail.id + '.' + detail.img"></img></div>
        <div class="details">
          <div class="beatName">{{decodeValue(detail.beatname)}}</div>
          <div class="authorName">{{decodeValue(detail.authorName)}}</div>
          <hr/>
          <div class="beatText">{{decodeValue(detail.beattext)}}</div>
          <div class="difficulties">
            <div class="difficulty-tag">{{detail.beatsPerMinute}} bpm</div>
            <div class="difficulty-tag" v-for="diff in getDifficulties()">{{diff}}</div>
          </div>
          <div class="social">
            <div><i class="icon-download"></i> {{detail.downloads}}</div>
            <div><i class="icon-music"></i> {{detail.plays}}</div>
            <div><i class="icon-thumbs-up"></i> {{detail.upvotes}}</div>
            <div class="download">
              <div class="button"><a :href="'https://beatsaver.com/dl.php?id=' + detail.id">Upvote <i class="icon-thumbs-up"></i></a></div>
              <div class="button"><a :href="'https://beatsaver.com/dl.php?id=' + detail.id">Download <i class="icon-download"></i></a></div>
            </div>
          </div>
        </div>
      </div>

      <div class="info">
        <div>
          <!-- <div>Difficulty Levels</div> -->
          <table>
            <tr class="diff" v-for="diff in detail.difficultyLevels">
              <td v-if="diff.stats">{{diff.difficulty}}</td>
              <td v-if="diff.stats" title="Duration"><i class="icon-clock"/>{{formatDuration(diff.stats.time)}}</td>
              <td v-if="diff.stats" title="Notes"><i class="icon-note"/>{{diff.stats.notes}}</td>
              <td v-if="diff.stats" title="Obstacles"><i class="icon-bomb"/>{{diff.stats.obstacles}}</td>
              <td v-if="diff.stats" title="Events"><i class="icon-flash"/>{{diff.stats.events}}</td>
            </tr>
          </table>
        </div>
      </div>

      <vue-disqus shortname="beatsaver" url="https://beatsaver.disqus.com/embed.js"></vue-disqus>
    </div>
  </div>
</template>

<script>
  require('../css/button.css');
  require('../css/menu.css');
  export default {
    'name': 'Detail',
    'data': function() {
      return {
        'detail': null
      }
    },
    'created': function() {
      this.$http.get('https://beatsaver.com/api.php?mode=details&id=' + this.$route.params.id)
      .then((res) => {
        this.detail = res.body[0];
      });

    },
    'methods': {
      'decodeValue': function(input) {
        var e = document.createElement('div');
        e.innerHTML = input;
        return e.childNodes.length === 0 ? "" : e.childNodes[0].nodeValue;
      },
      'getDifficulties': function() {
        if(!this.detail.difficultyLevels) return [];
        return this.detail.difficultyLevels.map((diff) => {
          return diff.difficulty;
        })
      },
      'formatDuration': function(duration) {
        const time = duration / this.detail.beatsPerMinute * 60
        const minutes = Math.floor(time / 60);
        const seconds = Math.floor(time - minutes * 60);
        const resMin = minutes ? minutes + 'm ' : '';
        const resSec = seconds ? seconds + 's' : '';
        return resMin + resSec;
      }
    }
  }
</script>

<style scoped>
  .content {
    margin-left:auto;
    margin-right:auto;
    color:white;
    width: 1000px;

    display: flex;
    flex-direction: column;
  }

  .detail-container {
    background-image: url("../assets/bg_blurred.jpg");
    background-repeat: no-repeat;
    background-attachment: fixed;
    background-size: cover;

    border-radius: 15px;

    display: flex;
    flex-direction: column;
    padding:10px;
  }

  .detail {
    display: flex;
    flex-direction: row;
    flex-wrap: nowrap;
    margin-bottom: 20px;
  }

  .details {
    flex-grow:1;
    display:flex;
    flex-direction: column;
    padding: 5px;
  }

  hr {
    width:100%;
  }

  .beatName {
    font-size:36px;
    overflow-wrap: break-word;
  }

  .authorName {
    font-size:30px;
  }

  .beatText {
    margin-top:10px;
    font-size: 14px;
    flex-grow:1;
  }

  .difficulties {
    display:flex;
    flex-direction: row;
  }

  .difficulty-tag {
    font-size: 20px;
    color: black;
    background-color:white;
    padding:3px;
    border-radius:2px;
    margin:2px;
  }

  .social {
    display:flex;
    flex-direction: row;
    margin-top:5px;
  }

  .social > div {
    margin-right:10px;
    font-size:20px;
  }

  .social a {
    color: inherit;
    text-decoration: none;
  }

  .download {
    margin-left: auto
  }

  .info {
    width:100%;
  }

  .diff {
    margin-bottom: 20px;
    font-size: 20px;
  }

  .diff td {
    padding:3px;
  }

  .cover img {
    margin-right:10px;
    height: 256px;
    width: 256px;
  }

  .download {
    margin-left: auto;
    padding: 0px 10px;
    border-top-left-radius: 30px;
    border-bottom-left-radius: 30px;
  }

  #disqus_thread {
    margin: 50px;
  }


</style>
